## gstvideo

gstvideo — Support library for video operations

## Functions

gboolean | gst_video_calculate_display_ratio ()
void | (*GstVideoConvertSampleCallback) ()
GstSample * | gst_video_convert_sample ()
void | gst_video_convert_sample_async ()
void | gst_video_alignment_reset ()
GstEvent * | gst_video_event_new_still_frame ()
gboolean | gst_video_event_parse_still_frame ()
GstEvent * | gst_video_event_new_downstream_force_key_unit ()
gboolean | gst_video_event_parse_downstream_force_key_unit ()
GstEvent * | gst_video_event_new_upstream_force_key_unit ()
gboolean | gst_video_event_parse_upstream_force_key_unit ()
gboolean | gst_video_event_is_force_key_unit ()
GstVideoChromaSite | gst_video_chroma_from_string ()
const gchar * | gst_video_chroma_to_string ()
void | (*GstVideoFormatUnpack) ()
void | (*GstVideoFormatPack) ()
#define | GST_VIDEO_FORMAT_INFO_FORMAT()
#define | GST_VIDEO_FORMAT_INFO_NAME()
#define | GST_VIDEO_FORMAT_INFO_FLAGS()
#define | GST_VIDEO_FORMAT_INFO_IS_YUV()
#define | GST_VIDEO_FORMAT_INFO_IS_RGB()
#define | GST_VIDEO_FORMAT_INFO_IS_GRAY()
#define | GST_VIDEO_FORMAT_INFO_HAS_ALPHA()
#define | GST_VIDEO_FORMAT_INFO_IS_LE()
#define | GST_VIDEO_FORMAT_INFO_HAS_PALETTE()
#define | GST_VIDEO_FORMAT_INFO_IS_COMPLEX()
#define | GST_VIDEO_FORMAT_INFO_BITS()
#define | GST_VIDEO_FORMAT_INFO_N_COMPONENTS()
#define | GST_VIDEO_FORMAT_INFO_SHIFT()
#define | GST_VIDEO_FORMAT_INFO_DEPTH()
#define | GST_VIDEO_FORMAT_INFO_PSTRIDE()
#define | GST_VIDEO_FORMAT_INFO_N_PLANES()
#define | GST_VIDEO_FORMAT_INFO_PLANE()
#define | GST_VIDEO_FORMAT_INFO_POFFSET()
#define | GST_VIDEO_FORMAT_INFO_W_SUB()
#define | GST_VIDEO_FORMAT_INFO_H_SUB()
#define | GST_VIDEO_SUB_SCALE()
#define | GST_VIDEO_FORMAT_INFO_SCALE_WIDTH()
#define | GST_VIDEO_FORMAT_INFO_SCALE_HEIGHT()
#define | GST_VIDEO_FORMAT_INFO_DATA()
#define | GST_VIDEO_FORMAT_INFO_STRIDE()
#define | GST_VIDEO_FORMAT_INFO_OFFSET()
#define | GST_VIDEO_FORMAT_INFO_TILE_MODE()
#define | GST_VIDEO_FORMAT_INFO_TILE_WS()
#define | GST_VIDEO_FORMAT_INFO_TILE_HS()
GstVideoFormat | gst_video_format_from_masks ()
GstVideoFormat | gst_video_format_from_fourcc ()
guint32 | gst_video_format_to_fourcc ()
GstVideoFormat | gst_video_format_from_string ()
const gchar * | gst_video_format_to_string ()
const GstVideoFormatInfo * | gst_video_format_get_info ()
#define | GST_VIDEO_CAPS_MAKE()
gboolean | gst_video_colorimetry_matches ()
gboolean | gst_video_colorimetry_from_string ()
gchar * | gst_video_colorimetry_to_string ()
void | gst_video_color_range_offsets ()
#define | GST_VIDEO_INFO_FORMAT()
#define | GST_VIDEO_INFO_NAME()
#define | GST_VIDEO_INFO_IS_YUV()
#define | GST_VIDEO_INFO_IS_RGB()
#define | GST_VIDEO_INFO_IS_GRAY()
#define | GST_VIDEO_INFO_HAS_ALPHA()
#define | GST_VIDEO_INFO_INTERLACE_MODE()
#define | GST_VIDEO_INFO_IS_INTERLACED()
#define | GST_VIDEO_INFO_FLAGS()
#define | GST_VIDEO_INFO_WIDTH()
#define | GST_VIDEO_INFO_HEIGHT()
#define | GST_VIDEO_INFO_SIZE()
#define | GST_VIDEO_INFO_VIEWS()
#define | GST_VIDEO_INFO_PAR_N()
#define | GST_VIDEO_INFO_PAR_D()
#define | GST_VIDEO_INFO_FPS_N()
#define | GST_VIDEO_INFO_FPS_D()
#define | GST_VIDEO_INFO_FLAG_IS_SET()
#define | GST_VIDEO_INFO_FLAG_SET()
#define | GST_VIDEO_INFO_FLAG_UNSET()
#define | GST_VIDEO_INFO_N_PLANES()
#define | GST_VIDEO_INFO_PLANE_OFFSET()
#define | GST_VIDEO_INFO_PLANE_STRIDE()
#define | GST_VIDEO_INFO_N_COMPONENTS()
#define | GST_VIDEO_INFO_COMP_DEPTH()
#define | GST_VIDEO_INFO_COMP_DATA()
#define | GST_VIDEO_INFO_COMP_OFFSET()
#define | GST_VIDEO_INFO_COMP_STRIDE()
#define | GST_VIDEO_INFO_COMP_WIDTH()
#define | GST_VIDEO_INFO_COMP_HEIGHT()
#define | GST_VIDEO_INFO_COMP_PLANE()
#define | GST_VIDEO_INFO_COMP_PSTRIDE()
#define | GST_VIDEO_INFO_COMP_POFFSET()
void | gst_video_info_init ()
void | gst_video_info_set_format ()
gboolean | gst_video_info_from_caps ()
GstCaps * | gst_video_info_to_caps ()
gboolean | gst_video_info_convert ()
gboolean | gst_video_info_is_equal ()
void | gst_video_info_align ()
gboolean | gst_video_frame_map_id ()
gboolean | gst_video_frame_map ()
void | gst_video_frame_unmap ()
gboolean | gst_video_frame_copy ()
gboolean | gst_video_frame_copy_plane ()
#define | GST_VIDEO_FRAME_FORMAT()
#define | GST_VIDEO_FRAME_WIDTH()
#define | GST_VIDEO_FRAME_HEIGHT()
#define | GST_VIDEO_FRAME_SIZE()
#define | GST_VIDEO_FRAME_FLAGS()
#define | GST_VIDEO_FRAME_FLAG_IS_SET()
#define | GST_VIDEO_FRAME_IS_INTERLACED()
#define | GST_VIDEO_FRAME_IS_TFF()
#define | GST_VIDEO_FRAME_IS_RFF()
#define | GST_VIDEO_FRAME_IS_ONEFIELD()
#define | GST_VIDEO_FRAME_N_PLANES()
#define | GST_VIDEO_FRAME_PLANE_DATA()
#define | GST_VIDEO_FRAME_PLANE_OFFSET()
#define | GST_VIDEO_FRAME_PLANE_STRIDE()
#define | GST_VIDEO_FRAME_N_COMPONENTS()
#define | GST_VIDEO_FRAME_COMP_DEPTH()
#define | GST_VIDEO_FRAME_COMP_DATA()
#define | GST_VIDEO_FRAME_COMP_STRIDE()
#define | GST_VIDEO_FRAME_COMP_OFFSET()
#define | GST_VIDEO_FRAME_COMP_WIDTH()
#define | GST_VIDEO_FRAME_COMP_HEIGHT()
#define | GST_VIDEO_FRAME_COMP_PLANE()
#define | GST_VIDEO_FRAME_COMP_PSTRIDE()
#define | GST_VIDEO_FRAME_COMP_POFFSET()
guint | gst_video_tile_get_index ()
#define | GST_VIDEO_TILE_MAKE_MODE()
#define | GST_VIDEO_TILE_MODE_TYPE()
#define | GST_VIDEO_TILE_MODE_IS_INDEXED()
#define | GST_VIDEO_TILE_MAKE_STRIDE()
#define | GST_VIDEO_TILE_X_TILES()
#define | GST_VIDEO_TILE_Y_TILES()

## Types and Values

struct | GstVideoAlignment
#define | GST_META_TAG_VIDEO_STR
#define | GST_META_TAG_VIDEO_ORIENTATION_STR
#define | GST_META_TAG_VIDEO_SIZE_STR
#define | GST_META_TAG_VIDEO_COLORSPACE_STR
enum | GstVideoFormat
#define | GST_VIDEO_MAX_PLANES
#define | GST_VIDEO_MAX_COMPONENTS
struct | GstVideoFormatInfo
enum | GstVideoChromaSite
enum | GstVideoFormatFlags
enum | GstVideoPackFlags
#define | GST_VIDEO_SIZE_RANGE
#define | GST_VIDEO_FPS_RANGE
#define | GST_VIDEO_FORMATS_ALL
enum | GstVideoColorRange
enum | GstVideoColorMatrix
enum | GstVideoTransferFunction
enum | GstVideoColorPrimaries
| GstVideoColorimetry
struct | GstVideoInfo
enum | GstVideoInterlaceMode
enum | GstVideoFlags
struct | GstVideoFrame
enum | GstVideoFrameFlags
enum | GstVideoBufferFlags
enum | GstVideoTileType
enum | GstVideoTileMode

## Includes

    #include <gst/video/video.h>

## Description

This library contains some helper functions and includes the videosink and videofilter base classes.

## Functions

### gst_video_calculate_display_ratio ()

    gboolean
    gst_video_calculate_display_ratio (guint *dar_n,
                                       guint *dar_d,
                                       guint video_width,
                                       guint video_height,
                                       guint video_par_n,
                                       guint video_par_d,
                                       guint display_par_n,
                                       guint display_par_d);

Given the Pixel Aspect Ratio and size of an input video frame, and the pixel aspect ratio of the intended display device, calculates the actual display ratio the video will be rendered with.

#### Parameters

dar_n | Numerator of the calculated display_ratio |
dar_d | Denominator of the calculated display_ratio |
video_width | Width of the video frame in pixels |
video_height | Height of the video frame in pixels |
video_par_n | Numerator of the pixel aspect ratio of the input video. |
video_par_d | Denominator of the pixel aspect ratio of the input video. |
display_par_n | Numerator of the pixel aspect ratio of the display device |
display_par_d | Denominator of the pixel aspect ratio of the display device |

#### Returns

A boolean indicating success and a calculated Display Ratio in the dar_n and dar_d parameters. The return value is FALSE in the case of integer overflow or other error.

### GstVideoConvertSampleCallback ()

    void
    (*GstVideoConvertSampleCallback) (GstSample *sample,
                                      GError *error,
                                      gpointer user_data);

### gst_video_convert_sample ()

    GstSample *
    gst_video_convert_sample (GstSample *sample,
                              const GstCaps *to_caps,
                              GstClockTime timeout,
                              GError **error);

Converts a raw video buffer into the specified output caps.

The output caps can be any raw video formats or any image formats (jpeg, png, ...).

The width, height and pixel-aspect-ratio can also be specified in the output caps.

#### Parameters

sample | a GstSample |
to_caps | the GstCaps to convert to |
timeout | the maximum amount of time allowed for the processing. |
error | pointer to a GError. Can be `NULL`. |

#### Returns

The converted GstSample, or `NULL` if an error happened (in which case `err` will point to the GError).

### gst_video_convert_sample_async ()

    void
    gst_video_convert_sample_async (GstSample *sample,
                                    const GstCaps *to_caps,
                                    GstClockTime timeout,
                                    GstVideoConvertSampleCallback callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy_notify);

Converts a raw video buffer into the specified output caps.

The output caps can be any raw video formats or any image formats (jpeg, png, ...).

The width, height and pixel-aspect-ratio can also be specified in the output caps.

`callback` will be called after conversion, when an error occured or if conversion didn't finish after `timeout` . `callback` will always be called from the thread default `GMainContext`, see `g_main_context_get_thread_default()`. If GLib before 2.22 is used, this will always be the global default main context.

`destroy_notify` will be called after the callback was called and `user_data` is not needed anymore.

#### Parameters

sample | a GstSample |
to_caps | the GstCaps to convert to |
timeout | the maximum amount of time allowed for the processing. |
callback | `GstVideoConvertSampleCallback` that will be called after conversion. |
user_data | extra data that will be passed to the `callback` |
destroy_notify | `GDestroyNotify` to be called after `user_data` is not needed anymore |

### gst_video_alignment_reset ()

    void
    gst_video_alignment_reset (GstVideoAlignment *align);

Set `align` to its default values with no padding and no alignment.

#### Parameters

align | a GstVideoAlignment |

### gst_video_event_new_still_frame ()

    GstEvent *
    gst_video_event_new_still_frame (gboolean in_still);

Creates a new Still Frame event. If `in_still` is `TRUE`, then the event represents the start of a still frame sequence. If it is `FALSE`, then the event ends a still frame sequence.

To parse an event created by `gst_video_event_new_still_frame()` use `gst_video_event_parse_still_frame()`.

#### Parameters

in_still | boolean value for the still-frame state of the event. |

#### Returns

The new GstEvent

### gst_video_event_parse_still_frame ()

    gboolean
    gst_video_event_parse_still_frame (GstEvent *event,
                                       gboolean *in_still);

Parse a GstEvent, identify if it is a Still Frame event, and return the still-frame state from the event if it is. If the event represents the start of a still frame, the in_still variable will be set to TRUE, otherwise FALSE. It is OK to pass NULL for the in_still variable order to just check whether the event is a valid still-frame event.

Create a still frame event using `gst_video_event_new_still_frame()`

#### Parameters

event | A GstEvent to parse |
in_still | A boolean to receive the still-frame status from the event, or NULL |

#### Returns

`TRUE` if the event is a valid still-frame event. `FALSE` if not

### gst_video_event_new_downstream_force_key_unit ()

    GstEvent *
    gst_video_event_new_downstream_force_key_unit
                                   (GstClockTime timestamp,
                                    GstClockTime stream_time,
                                    GstClockTime running_time,
                                    gboolean all_headers,
                                    guint count);

Creates a new downstream force key unit event. A downstream force key unit event can be sent down the pipeline to request downstream elements to produce a key unit. A downstream force key unit event must also be sent when handling an upstream force key unit event to notify downstream that the latter has been handled.

To parse an event created by `gst_video_event_new_downstream_force_key_unit()` use `gst_video_event_parse_downstream_force_key_unit()`.

#### Parameters

timestamp | the timestamp of the buffer that starts a new key unit |
stream_time | the stream_time of the buffer that starts a new key unit |
running_time | the running_time of the buffer that starts a new key unit |
all_headers | `TRUE` to produce headers when starting a new key unit |
count | integer that can be used to number key units |

#### Returns

The new GstEvent

### gst_video_event_parse_downstream_force_key_unit ()

    gboolean
    gst_video_event_parse_downstream_force_key_unit
                                   (GstEvent *event,
                                    GstClockTime *timestamp,
                                    GstClockTime *stream_time,
                                    GstClockTime *running_time,
                                    gboolean *all_headers,
                                    guint *count);

Get timestamp, stream-time, running-time, all-headers and count in the force key unit event. See `gst_video_event_new_downstream_force_key_unit()` for a full description of the downstream force key unit event.

`running_time` will be adjusted for any pad offsets of pads it was passing through.

#### Parameters

event | A GstEvent to parse |
timestamp | A pointer to the timestamp in the event. | [out]
stream_time | A pointer to the stream-time in the event. | [out]
running_time | A pointer to the running-time in the event. | [out]
all_headers | A pointer to the all_headers flag in the event. | [out]
count | A pointer to the count field of the event. | [out]

#### Returns

`TRUE` if the event is a valid downstream force key unit event.

### gst_video_event_new_upstream_force_key_unit ()

    GstEvent *
    gst_video_event_new_upstream_force_key_unit
                                   (GstClockTime running_time,
                                    gboolean all_headers,
                                    guint count);

Creates a new upstream force key unit event. An upstream force key unit event can be sent to request upstream elements to produce a key unit.

`running_time` can be set to request a new key unit at a specific running_time. If set to GST_CLOCK_TIME_NONE, upstream elements will produce a new key unit as soon as possible.

To parse an event created by `gst_video_event_new_downstream_force_key_unit()` use `gst_video_event_parse_downstream_force_key_unit()`.

#### Parameters

running_time | the running_time at which a new key unit should be produced |
all_headers | `TRUE` to produce headers when starting a new key unit |
count | integer that can be used to number key units |

#### Returns

The new GstEvent

### gst_video_event_parse_upstream_force_key_unit ()

    gboolean
    gst_video_event_parse_upstream_force_key_unit
                                   (GstEvent *event,
                                    GstClockTime *running_time,
                                    gboolean *all_headers,
                                    guint *count);

Get running-time, all-headers and count in the force key unit event. See `gst_video_event_new_upstream_force_key_unit()` for a full description of the upstream force key unit event.

Create an upstream force key unit event using `gst_video_event_new_upstream_force_key_unit()`

`running_time` will be adjusted for any pad offsets of pads it was passing through.

#### Parameters

event | A GstEvent to parse |
running_time | A pointer to the running_time in the event. | [out]
all_headers | A pointer to the all_headers flag in the event. | [out]
count | A pointer to the count field in the event. | [out]

#### Returns

`TRUE` if the event is a valid upstream force-key-unit event. `FALSE` if not

### gst_video_event_is_force_key_unit ()

    gboolean
    gst_video_event_is_force_key_unit (GstEvent *event);

Checks if an event is a force key unit event. Returns true for both upstream and downstream force key unit events.

#### Parameters

event | A GstEvent to check |

#### Returns

`TRUE` if the event is a valid force key unit event

### gst_video_chroma_from_string ()

    GstVideoChromaSite
    gst_video_chroma_from_string (const gchar *s);

Convert `s` to a GstVideoChromaSite

#### Parameters

s | a chromasite string |

#### Returns

a GstVideoChromaSite or `GST_VIDEO_CHROMA_SITE_UNKNOWN` when `s` does not contain a valid chroma description.

### gst_video_chroma_to_string ()

    const gchar *
    gst_video_chroma_to_string (GstVideoChromaSite site);

Converts `site` to its string representation.

#### Parameters

site | a GstVideoChromaSite |

#### Returns

a string describing `site` .

### GstVideoFormatUnpack ()

    void
    (*GstVideoFormatUnpack) (const GstVideoFormatInfo *info,
                             GstVideoPackFlags flags,
                             gpointer dest,
                             const gpointer data[GST_VIDEO_MAX_PLANES],
                             const gint stride[GST_VIDEO_MAX_PLANES],
                             gint x,
                             gint y,
                             gint width);

Unpacks `width` pixels from the given planes and strides containing data of format `info` . The pixels will be unpacked into `dest` which each component interleaved. `dest` should at least be big enough to hold `width` * n_components * size(unpack_format) bytes.

For subsampled formats, the components will be duplicated in the destination array. Reconstruction of the missing components can be performed in a separate step after unpacking.

#### Parameters

info | a GstVideoFormatInfo |
flags | flags to control the unpacking |
dest | a destination array |
data | pointers to the data planes |
stride | strides of the planes |
x | the x position in the image to start from |
y | the y position in the image to start from |
width | the amount of pixels to unpack. |

### GstVideoFormatPack ()

    void
    (*GstVideoFormatPack) (const GstVideoFormatInfo *info,
                           GstVideoPackFlags flags,
                           const gpointer src,
                           gint sstride,
                           gpointer data[GST_VIDEO_MAX_PLANES],
                           const gint stride[GST_VIDEO_MAX_PLANES],
                           GstVideoChromaSite chroma_site,
                           gint y,
                           gint width);

Packs `width` pixels from `src` to the given planes and strides in the format `info` . The pixels from source have each component interleaved and will be packed into the planes in `data` .

This function operates on pack_lines lines, meaning that `src` should contain at least pack_lines lines with a stride of `sstride` and `y` should be a multiple of pack_lines.

Subsampled formats will use the horizontally cosited component in the destination. Subsampling should be performed before packing.

Because tis function does not have a x coordinate, it is not possible to pack pixels starting from an unaligned position. For tiled images this means that packing should start from a tile coordinate. For subsampled formats this means that a complete pixel need to be packed.

#### Parameters

info | a GstVideoFormatInfo |
flags | flags to control the packing |
src | a source array |
sstride | the source array stride |
data | pointers to the destination data planes |
stride | strides of the destination planes |
chroma_site | the chroma siting of the target when subsampled (not used) |
y | the y position in the image to pack to |
width | the amount of pixels to pack. |

### GST_VIDEO_FORMAT_INFO_FORMAT()

    #define GST_VIDEO_FORMAT_INFO_FORMAT(info)       ((info)->format)

### GST_VIDEO_FORMAT_INFO_NAME()

    #define GST_VIDEO_FORMAT_INFO_NAME(info)         ((info)->name)

### GST_VIDEO_FORMAT_INFO_FLAGS()

    #define GST_VIDEO_FORMAT_INFO_FLAGS(info)        ((info)->flags)

### GST_VIDEO_FORMAT_INFO_IS_YUV()

    #define GST_VIDEO_FORMAT_INFO_IS_YUV(info)       ((info)->flags & GST_VIDEO_FORMAT_FLAG_YUV)

### GST_VIDEO_FORMAT_INFO_IS_RGB()

    #define GST_VIDEO_FORMAT_INFO_IS_RGB(info)       ((info)->flags & GST_VIDEO_FORMAT_FLAG_RGB)

### GST_VIDEO_FORMAT_INFO_IS_GRAY()

    #define GST_VIDEO_FORMAT_INFO_IS_GRAY(info)      ((info)->flags & GST_VIDEO_FORMAT_FLAG_GRAY)

### GST_VIDEO_FORMAT_INFO_HAS_ALPHA()

    #define GST_VIDEO_FORMAT_INFO_HAS_ALPHA(info)    ((info)->flags & GST_VIDEO_FORMAT_FLAG_ALPHA)

### GST_VIDEO_FORMAT_INFO_IS_LE()

    #define GST_VIDEO_FORMAT_INFO_IS_LE(info)        ((info)->flags & GST_VIDEO_FORMAT_FLAG_LE)

### GST_VIDEO_FORMAT_INFO_HAS_PALETTE()

    #define GST_VIDEO_FORMAT_INFO_HAS_PALETTE(info)  ((info)->flags & GST_VIDEO_FORMAT_FLAG_PALETTE)

### GST_VIDEO_FORMAT_INFO_IS_COMPLEX()

    #define GST_VIDEO_FORMAT_INFO_IS_COMPLEX(info)   ((info)->flags & GST_VIDEO_FORMAT_FLAG_COMPLEX)

### GST_VIDEO_FORMAT_INFO_BITS()

    #define GST_VIDEO_FORMAT_INFO_BITS(info)         ((info)->bits)

### GST_VIDEO_FORMAT_INFO_N_COMPONENTS()

    #define GST_VIDEO_FORMAT_INFO_N_COMPONENTS(info) ((info)->n_components)

### GST_VIDEO_FORMAT_INFO_SHIFT()

    #define GST_VIDEO_FORMAT_INFO_SHIFT(info,c)      ((info)->shift[c])

### GST_VIDEO_FORMAT_INFO_DEPTH()

    #define GST_VIDEO_FORMAT_INFO_DEPTH(info,c)      ((info)->depth[c])

### GST_VIDEO_FORMAT_INFO_PSTRIDE()

    #define GST_VIDEO_FORMAT_INFO_PSTRIDE(info,c)    ((info)->pixel_stride[c])

pixel stride for the given component. This is the amount of bytes to the pixel immediately to the right, so basically bytes from one pixel to the next. When bits < 8, the stride is expressed in bits.

Examples: for 24-bit RGB, the pixel stride would be 3 bytes, while it would be 4 bytes for RGBx or ARGB, and 8 bytes for ARGB64 or AYUV64. For planar formats such as I420 the pixel stride is usually 1. For YUY2 it would be 2 bytes.

### GST_VIDEO_FORMAT_INFO_N_PLANES()

    #define GST_VIDEO_FORMAT_INFO_N_PLANES(info)     ((info)->n_planes)

Number of planes. This is the number of planes the pixel layout is organized in in memory. The number of planes can be less than the number of components (e.g. Y,U,V,A or R, G, B, A) when multiple components are packed into one plane.

Examples: RGB/RGBx/RGBA: 1 plane, 3/3/4 components; I420: 3 planes, 3 components; NV21/NV12: 2 planes, 3 components.

### GST_VIDEO_FORMAT_INFO_PLANE()

    #define GST_VIDEO_FORMAT_INFO_PLANE(info,c)      ((info)->plane[c])

Plane number where the given component can be found. A plane may contain data for multiple components.

### GST_VIDEO_FORMAT_INFO_POFFSET()

    #define GST_VIDEO_FORMAT_INFO_POFFSET(info,c)    ((info)->poffset[c])

### GST_VIDEO_FORMAT_INFO_W_SUB()

    #define GST_VIDEO_FORMAT_INFO_W_SUB(info,c)      ((info)->w_sub[c])

### GST_VIDEO_FORMAT_INFO_H_SUB()

    #define GST_VIDEO_FORMAT_INFO_H_SUB(info,c)      ((info)->h_sub[c])

### GST_VIDEO_SUB_SCALE()

    #define GST_VIDEO_SUB_SCALE(scale,val)   (-((-((gint)(val)))>>(scale)))

### GST_VIDEO_FORMAT_INFO_SCALE_WIDTH()

    #define GST_VIDEO_FORMAT_INFO_SCALE_WIDTH(info,c,w)  GST_VIDEO_SUB_SCALE ((info)->w_sub[c],(w))

### GST_VIDEO_FORMAT_INFO_SCALE_HEIGHT()

    #define GST_VIDEO_FORMAT_INFO_SCALE_HEIGHT(info,c,h) GST_VIDEO_SUB_SCALE ((info)->h_sub[c],(h))

### GST_VIDEO_FORMAT_INFO_DATA()

    #define             GST_VIDEO_FORMAT_INFO_DATA(info,planes,comp)

### GST_VIDEO_FORMAT_INFO_STRIDE()

    #define GST_VIDEO_FORMAT_INFO_STRIDE(info,strides,comp) ((strides)[(info)->plane[comp]])

Row stride in bytes, that is number of bytes from the first pixel component of a row to the first pixel component in the next row. This might include some row padding (memory not actually used for anything, to make sure the beginning of the next row is aligned in a particular way).

### GST_VIDEO_FORMAT_INFO_OFFSET()

    #define             GST_VIDEO_FORMAT_INFO_OFFSET(info,offsets,comp)

### GST_VIDEO_FORMAT_INFO_TILE_MODE()

    #define GST_VIDEO_FORMAT_INFO_TILE_MODE(info) ((info)->tile_mode)

### GST_VIDEO_FORMAT_INFO_TILE_WS()

    #define GST_VIDEO_FORMAT_INFO_TILE_WS(info) ((info)->tile_ws)

### GST_VIDEO_FORMAT_INFO_TILE_HS()

    #define GST_VIDEO_FORMAT_INFO_TILE_HS(info) ((info)->tile_hs)

### gst_video_format_from_masks ()

    GstVideoFormat
    gst_video_format_from_masks (gint depth,
                                 gint bpp,
                                 gint endianness,
                                 guint red_mask,
                                 guint green_mask,
                                 guint blue_mask,
                                 guint alpha_mask);

Find the GstVideoFormat for the given parameters.

#### Parameters

depth | the amount of bits used for a pixel |
bpp | the amount of bits used to store a pixel. This value is bigger than `depth` |
endianness | the endianness of the masks, G_LITTLE_ENDIAN or G_BIG_ENDIAN |
red_mask | the red mask |
green_mask | the green mask |
blue_mask | the blue mask |
alpha_mask | the alpha mask, or 0 if no alpha mask |

#### Returns

a GstVideoFormat or GST_VIDEO_FORMAT_UNKNOWN when the parameters to not specify a known format.

### gst_video_format_from_fourcc ()

    GstVideoFormat
    gst_video_format_from_fourcc (guint32 fourcc);

Converts a FOURCC value into the corresponding GstVideoFormat. If the FOURCC cannot be represented by GstVideoFormat, GST_VIDEO_FORMAT_UNKNOWN is returned.

#### Parameters

fourcc | a FOURCC value representing raw YUV video |

#### Returns

the GstVideoFormat describing the FOURCC value

### gst_video_format_to_fourcc ()

    guint32
    gst_video_format_to_fourcc (GstVideoFormat format);

Converts a GstVideoFormat value into the corresponding FOURCC. Only a few YUV formats have corresponding FOURCC values. If `format` has no corresponding FOURCC value, 0 is returned.

#### Parameters

format | a GstVideoFormat video format |

#### Returns

the FOURCC corresponding to `format`

### gst_video_format_from_string ()

    GstVideoFormat
    gst_video_format_from_string (const gchar *format);

Convert the `format` string to its GstVideoFormat.

#### Parameters

format | a format string |

#### Returns

the GstVideoFormat for `format` or GST_VIDEO_FORMAT_UNKNOWN when the string is not a known format.

### gst_video_format_to_string ()

    const gchar *
    gst_video_format_to_string (GstVideoFormat format);

### gst_video_format_get_info ()

    const GstVideoFormatInfo *
    gst_video_format_get_info (GstVideoFormat format);

Get the GstVideoFormatInfo for `format`

#### Parameters

format | a GstVideoFormat |

#### Returns

The GstVideoFormatInfo for `format` .

### GST_VIDEO_CAPS_MAKE()

    #define             GST_VIDEO_CAPS_MAKE(format)

Generic caps string for video, for use in pad templates.

#### Parameters

format | string format that describes the pixel layout, as string (e.g. "I420", "RGB", "YV12", "YUY2", "AYUV", etc.) |

### gst_video_colorimetry_matches ()

    gboolean
    gst_video_colorimetry_matches (GstVideoColorimetry *cinfo,
                                   const gchar *color);

Check if the colorimetry information in `info` matches that of the string `color` .

#### Parameters

cinfo | a GstVideoInfo |
color | a colorimetry string |

#### Returns

TRUE if `color` conveys the same colorimetry info as the color information in `info` .

### gst_video_colorimetry_from_string ()

    gboolean
    gst_video_colorimetry_from_string (GstVideoColorimetry *cinfo,
                                       const gchar *color);

Parse the colorimetry string and update `cinfo` with the parsed values.

#### Parameters

cinfo | a GstVideoColorimetry |
color | a colorimetry string |

#### Returns

TRUE if `color` points to valid colorimetry info.

### gst_video_colorimetry_to_string ()

    gchar *
    gst_video_colorimetry_to_string (GstVideoColorimetry *cinfo);

Make a string representation of `cinfo` .

#### Parameters

cinfo | a GstVideoColorimetry |

#### Returns

a string representation of `cinfo` .

### gst_video_color_range_offsets ()

    void
    gst_video_color_range_offsets (GstVideoColorRange range,
                                   const GstVideoFormatInfo *info,
                                   gint offset[GST_VIDEO_MAX_COMPONENTS],
                                   gint scale[GST_VIDEO_MAX_COMPONENTS]);

Compute the offset and scale values for each component of `info` . For each component, (c[i] - offset[i]) / scale[i] will scale the component c[i] to the range [0.0 .. 1.0].

The reverse operation (c[i] * scale[i]) + offset[i] can be used to convert the component values in range [0.0 .. 1.0] back to their representation in `info` and `range` .

#### Parameters

range | a GstVideoColorRange |
info | a GstVideoFormatInfo |
offset | output offsets. | [out]
scale | output scale. | [out]

### GST_VIDEO_INFO_FORMAT()

    #define GST_VIDEO_INFO_FORMAT(i)         (GST_VIDEO_FORMAT_INFO_FORMAT((i)->finfo))

### GST_VIDEO_INFO_NAME()

    #define GST_VIDEO_INFO_NAME(i)           (GST_VIDEO_FORMAT_INFO_NAME((i)->finfo))

### GST_VIDEO_INFO_IS_YUV()

    #define GST_VIDEO_INFO_IS_YUV(i)         (GST_VIDEO_FORMAT_INFO_IS_YUV((i)->finfo))

### GST_VIDEO_INFO_IS_RGB()

    #define GST_VIDEO_INFO_IS_RGB(i)         (GST_VIDEO_FORMAT_INFO_IS_RGB((i)->finfo))

### GST_VIDEO_INFO_IS_GRAY()

    #define GST_VIDEO_INFO_IS_GRAY(i)        (GST_VIDEO_FORMAT_INFO_IS_GRAY((i)->finfo))

### GST_VIDEO_INFO_HAS_ALPHA()

    #define GST_VIDEO_INFO_HAS_ALPHA(i)      (GST_VIDEO_FORMAT_INFO_HAS_ALPHA((i)->finfo))

### GST_VIDEO_INFO_INTERLACE_MODE()

    #define GST_VIDEO_INFO_INTERLACE_MODE(i) ((i)->interlace_mode)

### GST_VIDEO_INFO_IS_INTERLACED()

    #define GST_VIDEO_INFO_IS_INTERLACED(i)  ((i)->interlace_mode != GST_VIDEO_INTERLACE_MODE_PROGRESSIVE)

### GST_VIDEO_INFO_FLAGS()

    #define GST_VIDEO_INFO_FLAGS(i)          ((i)->flags)

### GST_VIDEO_INFO_WIDTH()

    #define GST_VIDEO_INFO_WIDTH(i)          ((i)->width)

### GST_VIDEO_INFO_HEIGHT()

    #define GST_VIDEO_INFO_HEIGHT(i)         ((i)->height)

### GST_VIDEO_INFO_SIZE()

    #define GST_VIDEO_INFO_SIZE(i)           ((i)->size)

### GST_VIDEO_INFO_VIEWS()

    #define GST_VIDEO_INFO_VIEWS(i)          ((i)->views)

### GST_VIDEO_INFO_PAR_N()

    #define GST_VIDEO_INFO_PAR_N(i)          ((i)->par_n)

### GST_VIDEO_INFO_PAR_D()

    #define GST_VIDEO_INFO_PAR_D(i)          ((i)->par_d)

### GST_VIDEO_INFO_FPS_N()

    #define GST_VIDEO_INFO_FPS_N(i)          ((i)->fps_n)

### GST_VIDEO_INFO_FPS_D()

    #define GST_VIDEO_INFO_FPS_D(i)          ((i)->fps_d)

### GST_VIDEO_INFO_FLAG_IS_SET()

    #define GST_VIDEO_INFO_FLAG_IS_SET(i,flag) ((GST_VIDEO_INFO_FLAGS(i) & (flag)) == (flag))

### GST_VIDEO_INFO_FLAG_SET()

    #define GST_VIDEO_INFO_FLAG_SET(i,flag)    (GST_VIDEO_INFO_FLAGS(i) |= (flag))

### GST_VIDEO_INFO_FLAG_UNSET()

    #define GST_VIDEO_INFO_FLAG_UNSET(i,flag)  (GST_VIDEO_INFO_FLAGS(i) &= ~(flag))

### GST_VIDEO_INFO_N_PLANES()

    #define GST_VIDEO_INFO_N_PLANES(i)       (GST_VIDEO_FORMAT_INFO_N_PLANES((i)->finfo))

### GST_VIDEO_INFO_PLANE_OFFSET()

    #define GST_VIDEO_INFO_PLANE_OFFSET(i,p) ((i)->offset[p])

### GST_VIDEO_INFO_PLANE_STRIDE()

    #define GST_VIDEO_INFO_PLANE_STRIDE(i,p) ((i)->stride[p])

### GST_VIDEO_INFO_N_COMPONENTS()

    #define GST_VIDEO_INFO_N_COMPONENTS(i)   GST_VIDEO_FORMAT_INFO_N_COMPONENTS((i)->finfo)

### GST_VIDEO_INFO_COMP_DEPTH()

    #define GST_VIDEO_INFO_COMP_DEPTH(i,c)   GST_VIDEO_FORMAT_INFO_DEPTH((i)->finfo,(c))

### GST_VIDEO_INFO_COMP_DATA()

    #define GST_VIDEO_INFO_COMP_DATA(i,d,c)  GST_VIDEO_FORMAT_INFO_DATA((i)->finfo,d,(c))

### GST_VIDEO_INFO_COMP_OFFSET()

    #define GST_VIDEO_INFO_COMP_OFFSET(i,c)  GST_VIDEO_FORMAT_INFO_OFFSET((i)->finfo,(i)->offset,(c))

### GST_VIDEO_INFO_COMP_STRIDE()

    #define GST_VIDEO_INFO_COMP_STRIDE(i,c)  GST_VIDEO_FORMAT_INFO_STRIDE((i)->finfo,(i)->stride,(c))

### GST_VIDEO_INFO_COMP_WIDTH()

    #define GST_VIDEO_INFO_COMP_WIDTH(i,c)   GST_VIDEO_FORMAT_INFO_SCALE_WIDTH((i)->finfo,(c),(i)->width)

### GST_VIDEO_INFO_COMP_HEIGHT()

    #define GST_VIDEO_INFO_COMP_HEIGHT(i,c)  GST_VIDEO_FORMAT_INFO_SCALE_HEIGHT((i)->finfo,(c),(i)->height)

### GST_VIDEO_INFO_COMP_PLANE()

    #define GST_VIDEO_INFO_COMP_PLANE(i,c)   GST_VIDEO_FORMAT_INFO_PLANE((i)->finfo,(c))

### GST_VIDEO_INFO_COMP_PSTRIDE()

    #define GST_VIDEO_INFO_COMP_PSTRIDE(i,c) GST_VIDEO_FORMAT_INFO_PSTRIDE((i)->finfo,(c))

### GST_VIDEO_INFO_COMP_POFFSET()

    #define GST_VIDEO_INFO_COMP_POFFSET(i,c) GST_VIDEO_FORMAT_INFO_POFFSET((i)->finfo,(c))

### gst_video_info_init ()

    void
    gst_video_info_init (GstVideoInfo *info);

Initialize `info` with default values.

#### Parameters

info | a GstVideoInfo |

### gst_video_info_set_format ()

    void
    gst_video_info_set_format (GstVideoInfo *info,
                               GstVideoFormat format,
                               guint width,
                               guint height);

Set the default info for a video frame of `format` and `width` and `height` .

Note: This initializes `info` first, no values are preserved.

#### Parameters

info | a GstVideoInfo |
format | the format |
width | a width |
height | a height |

### gst_video_info_from_caps ()

    gboolean
    gst_video_info_from_caps (GstVideoInfo *info,
                              const GstCaps *caps);

Parse `caps` and update `info` .

#### Parameters

info | a GstVideoInfo |
caps | a GstCaps |

#### Returns

TRUE if `caps` could be parsed

### gst_video_info_to_caps ()

    GstCaps *
    gst_video_info_to_caps (GstVideoInfo *info);

Convert the values of `info` into a GstCaps.

#### Parameters

info | a GstVideoInfo |

#### Returns

a new GstCaps containing the info of `info` .

### gst_video_info_convert ()

    gboolean
    gst_video_info_convert (GstVideoInfo *info,
                            GstFormat src_format,
                            gint64 src_value,
                            GstFormat dest_format,
                            gint64 *dest_value);

Converts among various GstFormat types. This function handles GST_FORMAT_BYTES, GST_FORMAT_TIME, and GST_FORMAT_DEFAULT. For raw video, GST_FORMAT_DEFAULT corresponds to video frames. This function can be used to handle pad queries of the type GST_QUERY_CONVERT.

#### Parameters

info | a GstVideoInfo |
src_format | GstFormat of the `src_value` |
src_value | value to convert |
dest_format | GstFormat of the `dest_value` |
dest_value | pointer to destination value |

#### Returns

TRUE if the conversion was successful.

### gst_video_info_is_equal ()

    gboolean
    gst_video_info_is_equal (const GstVideoInfo *info,
                             const GstVideoInfo *other);

Compares two GstVideoInfo and returns whether they are equal or not

#### Parameters

info | a GstVideoInfo |
other | a GstVideoInfo |

#### Returns

`TRUE` if `info` and `other` are equal, else `FALSE`.

### gst_video_info_align ()

    void
    gst_video_info_align (GstVideoInfo *info,
                          GstVideoAlignment *align);

Adjust the offset and stride fields in `info` so that the padding and stride alignment in `align` is respected.

Extra padding will be added to the right side when stride alignment padding is required and `align` will be updated with the new padding values.

#### Parameters

info | a GstVideoInfo |
align | alignment parameters |

### gst_video_frame_map_id ()

    gboolean
    gst_video_frame_map_id (GstVideoFrame *frame,
                            GstVideoInfo *info,
                            GstBuffer *buffer,
                            gint id,
                            GstMapFlags flags);

Use `info` and `buffer` to fill in the values of `frame` with the video frame information of frame `id` .

When `id` is -1, the default frame is mapped. When `id` != -1, this function will return `FALSE` when there is no GstVideoMeta with that id.

All video planes of `buffer` will be mapped and the pointers will be set in `frame->data` .

#### Parameters

frame | pointer to GstVideoFrame |
info | a GstVideoInfo |
buffer | the buffer to map |
id | the frame id to map |
flags | GstMapFlags |

#### Returns

`TRUE` on success.

### gst_video_frame_map ()

    gboolean
    gst_video_frame_map (GstVideoFrame *frame,
                         GstVideoInfo *info,
                         GstBuffer *buffer,
                         GstMapFlags flags);

Use `info` and `buffer` to fill in the values of `frame` .

All video planes of `buffer` will be mapped and the pointers will be set in `frame->data` .

#### Parameters

frame | pointer to GstVideoFrame |
info | a GstVideoInfo |
buffer | the buffer to map |
flags | GstMapFlags |

#### Returns

`TRUE` on success.

### gst_video_frame_unmap ()

    void
    gst_video_frame_unmap (GstVideoFrame *frame);

Unmap the memory previously mapped with gst_video_frame_map.

#### Parameters

frame | a GstVideoFrame |

### gst_video_frame_copy ()

    gboolean
    gst_video_frame_copy (GstVideoFrame *dest,
                          const GstVideoFrame *src);

Copy the contents from `src` to `dest` .

#### Parameters

dest | a GstVideoFrame |
src | a GstVideoFrame |

#### Returns

TRUE if the contents could be copied.

### gst_video_frame_copy_plane ()

    gboolean
    gst_video_frame_copy_plane (GstVideoFrame *dest,
                                const GstVideoFrame *src,
                                guint plane);

Copy the plane with index `plane` from `src` to `dest` .

#### Parameters

dest | a GstVideoFrame |
src | a GstVideoFrame |
plane | a plane |

#### Returns

TRUE if the contents could be copied.

### GST_VIDEO_FRAME_FORMAT()

    #define GST_VIDEO_FRAME_FORMAT(f)         (GST_VIDEO_INFO_FORMAT(&(f)->info))

### GST_VIDEO_FRAME_WIDTH()

    #define GST_VIDEO_FRAME_WIDTH(f)          (GST_VIDEO_INFO_WIDTH(&(f)->info))

### GST_VIDEO_FRAME_HEIGHT()

    #define GST_VIDEO_FRAME_HEIGHT(f)         (GST_VIDEO_INFO_HEIGHT(&(f)->info))

### GST_VIDEO_FRAME_SIZE()

    #define GST_VIDEO_FRAME_SIZE(f)           (GST_VIDEO_INFO_SIZE(&(f)->info))

### GST_VIDEO_FRAME_FLAGS()

    #define GST_VIDEO_FRAME_FLAGS(f)          ((f)->flags)

### GST_VIDEO_FRAME_FLAG_IS_SET()

    #define GST_VIDEO_FRAME_FLAG_IS_SET(f,fl) ((GST_VIDEO_FRAME_FLAGS(f) & (fl)) == (fl))

### GST_VIDEO_FRAME_IS_INTERLACED()

    #define GST_VIDEO_FRAME_IS_INTERLACED(f)  (GST_VIDEO_FRAME_FLAG_IS_SET(f, GST_VIDEO_FRAME_FLAG_INTERLACED))

### GST_VIDEO_FRAME_IS_TFF()

    #define GST_VIDEO_FRAME_IS_TFF(f)         (GST_VIDEO_FRAME_FLAG_IS_SET(f, GST_VIDEO_FRAME_FLAG_TFF))

### GST_VIDEO_FRAME_IS_RFF()

    #define GST_VIDEO_FRAME_IS_RFF(f)         (GST_VIDEO_FRAME_FLAG_IS_SET(f, GST_VIDEO_FRAME_FLAG_RFF))

### GST_VIDEO_FRAME_IS_ONEFIELD()

    #define GST_VIDEO_FRAME_IS_ONEFIELD(f)    (GST_VIDEO_FRAME_FLAG_IS_SET(f, GST_VIDEO_FRAME_FLAG_ONEFIELD))

### GST_VIDEO_FRAME_N_PLANES()

    #define GST_VIDEO_FRAME_N_PLANES(f)       (GST_VIDEO_INFO_N_PLANES(&(f)->info))

### GST_VIDEO_FRAME_PLANE_DATA()

    #define GST_VIDEO_FRAME_PLANE_DATA(f,p)   ((f)->data[p])

### GST_VIDEO_FRAME_PLANE_OFFSET()

    #define GST_VIDEO_FRAME_PLANE_OFFSET(f,p) (GST_VIDEO_INFO_PLANE_OFFSET(&(f)->info,(p)))

### GST_VIDEO_FRAME_PLANE_STRIDE()

    #define GST_VIDEO_FRAME_PLANE_STRIDE(f,p) (GST_VIDEO_INFO_PLANE_STRIDE(&(f)->info,(p)))

### GST_VIDEO_FRAME_N_COMPONENTS()

    #define GST_VIDEO_FRAME_N_COMPONENTS(f)   GST_VIDEO_INFO_N_COMPONENTS(&(f)->info)

### GST_VIDEO_FRAME_COMP_DEPTH()

    #define GST_VIDEO_FRAME_COMP_DEPTH(f,c)   GST_VIDEO_INFO_COMP_DEPTH(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_DATA()

    #define GST_VIDEO_FRAME_COMP_DATA(f,c)    GST_VIDEO_INFO_COMP_DATA(&(f)->info,(f)->data,(c))

### GST_VIDEO_FRAME_COMP_STRIDE()

    #define GST_VIDEO_FRAME_COMP_STRIDE(f,c)  GST_VIDEO_INFO_COMP_STRIDE(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_OFFSET()

    #define GST_VIDEO_FRAME_COMP_OFFSET(f,c)  GST_VIDEO_INFO_COMP_OFFSET(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_WIDTH()

    #define GST_VIDEO_FRAME_COMP_WIDTH(f,c)   GST_VIDEO_INFO_COMP_WIDTH(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_HEIGHT()

    #define GST_VIDEO_FRAME_COMP_HEIGHT(f,c)  GST_VIDEO_INFO_COMP_HEIGHT(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_PLANE()

    #define GST_VIDEO_FRAME_COMP_PLANE(f,c)   GST_VIDEO_INFO_COMP_PLANE(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_PSTRIDE()

    #define GST_VIDEO_FRAME_COMP_PSTRIDE(f,c) GST_VIDEO_INFO_COMP_PSTRIDE(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_POFFSET()

    #define GST_VIDEO_FRAME_COMP_POFFSET(f,c) GST_VIDEO_INFO_COMP_POFFSET(&(f)->info,(c))

### gst_video_tile_get_index ()

    guint
    gst_video_tile_get_index (GstVideoTileMode mode,
                              gint x,
                              gint y,
                              gint x_tiles,
                              gint y_tiles);

Get the tile index of the tile at coordinates `x` and `y` in the tiled image of `x_tiles` by `y_tiles` .

Use this method when `mode` is of type `GST_VIDEO_TILE_MODE_INDEXED`.

#### Parameters

mode | a GstVideoTileMode |
x | x coordinate |
y | y coordinate |
x_tiles | number of horizintal tiles |
y_tiles | number of vertical tiles |

#### Returns

the index of the tile at `x` and `y` in the tiled image of `x_tiles` by `y_tiles` .

Since 1.4

### GST_VIDEO_TILE_MAKE_MODE()

    #define             GST_VIDEO_TILE_MAKE_MODE(num, type)

use this macro to create new tile modes.

#### Parameters

num | the mode number to create |
type | the tile mode type |

### GST_VIDEO_TILE_MODE_TYPE()

    #define GST_VIDEO_TILE_MODE_TYPE(mode)       ((mode) & GST_VIDEO_TILE_TYPE_MASK)

Get the tile mode type of `mode`

#### Parameters

mode | the tile mode |

### GST_VIDEO_TILE_MODE_IS_INDEXED()

    #define GST_VIDEO_TILE_MODE_IS_INDEXED(mode) (GST_VIDEO_TILE_MODE_TYPE(mode) == GST_VIDEO_TILE_TYPE_INDEXED)

Check if `mode` is an indexed tile type

#### Parameters

mode | a tile mode |

### GST_VIDEO_TILE_MAKE_STRIDE()

    #define             GST_VIDEO_TILE_MAKE_STRIDE(x_tiles, y_tiles)

Encode the number of tile in X and Y into the stride.

#### Parameters

x_tiles | number of tiles in X |
y_tiles | number of tiles in Y |

### GST_VIDEO_TILE_X_TILES()

    #define GST_VIDEO_TILE_X_TILES(stride) ((stride) & GST_VIDEO_TILE_X_TILES_MASK)

Extract the number of tiles in X from the stride value.

#### Parameters

stride | plane stride |

### GST_VIDEO_TILE_Y_TILES()

    #define GST_VIDEO_TILE_Y_TILES(stride) ((stride) >> GST_VIDEO_TILE_Y_TILES_SHIFT)

Extract the number of tiles in Y from the stride value.

#### Parameters

stride | plane stride |

## Types and Values

### struct GstVideoAlignment

    struct GstVideoAlignment {
      guint padding_top;
      guint padding_bottom;
      guint padding_left;
      guint padding_right;
      guint stride_align[GST_VIDEO_MAX_PLANES];
    };

Extra alignment paramters for the memory of video buffers. This structure is usually used to configure the bufferpool if it supports the GST_BUFFER_POOL_OPTION_VIDEO_ALIGNMENT.

#### Members

guint `padding_top`; | extra pixels on the top |
guint `padding_bottom`; | extra pixels on the bottom |
guint `padding_left`; | extra pixels on the left side |
guint `padding_right`; | extra pixels on the right side |
guint `stride_align`[GST_VIDEO_MAX_PLANES]; | array with extra alignment requirements for the strides |

### GST_META_TAG_VIDEO_STR

    #define GST_META_TAG_VIDEO_STR "video"

This metadata is relevant for video streams.

Since 1.2

### GST_META_TAG_VIDEO_ORIENTATION_STR

    #define GST_META_TAG_VIDEO_ORIENTATION_STR "orientation"

This metadata stays relevant as long as video orientation is unchanged.

Since 1.2

### GST_META_TAG_VIDEO_SIZE_STR

    #define GST_META_TAG_VIDEO_SIZE_STR "size"

This metadata stays relevant as long as video size is unchanged.

Since 1.2

### GST_META_TAG_VIDEO_COLORSPACE_STR

    #define GST_META_TAG_VIDEO_COLORSPACE_STR "colorspace"

This metadata stays relevant as long as video colorspace is unchanged.

Since 1.2

### enum GstVideoFormat

Enum value describing the most common video formats.

#### Members

GST_VIDEO_FORMAT_UNKNOWN | Unknown or unset video format id |
GST_VIDEO_FORMAT_ENCODED | Encoded video format. Only ever use that in caps for special video formats in combination with non-system memory GstCapsFeatures where it does not make sense to specify a real video format. |
GST_VIDEO_FORMAT_I420 | planar 4:2:0 YUV |
GST_VIDEO_FORMAT_YV12 | planar 4:2:0 YVU (like I420 but UV planes swapped) |
GST_VIDEO_FORMAT_YUY2 | packed 4:2:2 YUV (Y0-U0-Y1-V0 Y2-U2-Y3-V2 Y4 ...) |
GST_VIDEO_FORMAT_UYVY | packed 4:2:2 YUV (U0-Y0-V0-Y1 U2-Y2-V2-Y3 U4 ...) |
GST_VIDEO_FORMAT_AYUV | packed 4:4:4 YUV with alpha channel (A0-Y0-U0-V0 ...) |
GST_VIDEO_FORMAT_RGBx | sparse rgb packed into 32 bit, space last |
GST_VIDEO_FORMAT_BGRx | sparse reverse rgb packed into 32 bit, space last |
GST_VIDEO_FORMAT_xRGB | sparse rgb packed into 32 bit, space first |
GST_VIDEO_FORMAT_xBGR | sparse reverse rgb packed into 32 bit, space first |
GST_VIDEO_FORMAT_RGBA | rgb with alpha channel last |
GST_VIDEO_FORMAT_BGRA | reverse rgb with alpha channel last |
GST_VIDEO_FORMAT_ARGB | rgb with alpha channel first |
GST_VIDEO_FORMAT_ABGR | reverse rgb with alpha channel first |
GST_VIDEO_FORMAT_RGB | rgb |
GST_VIDEO_FORMAT_BGR | reverse rgb |
GST_VIDEO_FORMAT_Y41B | planar 4:1:1 YUV |
GST_VIDEO_FORMAT_Y42B | planar 4:2:2 YUV |
GST_VIDEO_FORMAT_YVYU | packed 4:2:2 YUV (Y0-V0-Y1-U0 Y2-V2-Y3-U2 Y4 ...) |
GST_VIDEO_FORMAT_Y444 | planar 4:4:4 YUV |
GST_VIDEO_FORMAT_v210 | packed 4:2:2 10-bit YUV, complex format |
GST_VIDEO_FORMAT_v216 | packed 4:2:2 16-bit YUV, Y0-U0-Y1-V1 order |
GST_VIDEO_FORMAT_NV12 | planar 4:2:0 YUV with interleaved UV plane |
GST_VIDEO_FORMAT_NV21 | planar 4:2:0 YUV with interleaved VU plane |
GST_VIDEO_FORMAT_GRAY8 | 8-bit grayscale |
GST_VIDEO_FORMAT_GRAY16_BE | 16-bit grayscale, most significant byte first |
GST_VIDEO_FORMAT_GRAY16_LE | 16-bit grayscale, least significant byte first |
GST_VIDEO_FORMAT_v308 | packed 4:4:4 YUV |
GST_VIDEO_FORMAT_RGB16 | rgb 5-6-5 bits per component |
GST_VIDEO_FORMAT_BGR16 | reverse rgb 5-6-5 bits per component |
GST_VIDEO_FORMAT_RGB15 | rgb 5-5-5 bits per component |
GST_VIDEO_FORMAT_BGR15 | reverse rgb 5-5-5 bits per component |
GST_VIDEO_FORMAT_UYVP | packed 10-bit 4:2:2 YUV (U0-Y0-V0-Y1 U2-Y2-V2-Y3 U4 ...) |
GST_VIDEO_FORMAT_A420 | planar 4:4:2:0 AYUV |
GST_VIDEO_FORMAT_RGB8P | 8-bit paletted RGB |
GST_VIDEO_FORMAT_YUV9 | planar 4:1:0 YUV |
GST_VIDEO_FORMAT_YVU9 | planar 4:1:0 YUV (like YUV9 but UV planes swapped) |
GST_VIDEO_FORMAT_IYU1 | packed 4:1:1 YUV (Cb-Y0-Y1-Cr-Y2-Y3 ...) |
GST_VIDEO_FORMAT_ARGB64 | rgb with alpha channel first, 16 bits per channel |
GST_VIDEO_FORMAT_AYUV64 | packed 4:4:4 YUV with alpha channel, 16 bits per channel (A0-Y0-U0-V0 ...) |
GST_VIDEO_FORMAT_r210 | packed 4:4:4 RGB, 10 bits per channel |
GST_VIDEO_FORMAT_I420_10BE | planar 4:2:0 YUV, 10 bits per channel |
GST_VIDEO_FORMAT_I420_10LE | planar 4:2:0 YUV, 10 bits per channel |
GST_VIDEO_FORMAT_I422_10BE | planar 4:2:2 YUV, 10 bits per channel |
GST_VIDEO_FORMAT_I422_10LE | planar 4:2:2 YUV, 10 bits per channel |
GST_VIDEO_FORMAT_Y444_10BE | planar 4:4:4 YUV, 10 bits per channel |
GST_VIDEO_FORMAT_Y444_10LE | planar 4:4:4 YUV, 10 bits per channel |
GST_VIDEO_FORMAT_GBR | planar 4:4:4 RGB, 8 bits per channel |
GST_VIDEO_FORMAT_GBR_10BE | planar 4:4:4 RGB, 10 bits per channel |
GST_VIDEO_FORMAT_GBR_10LE | planar 4:4:4 RGB, 10 bits per channel |
GST_VIDEO_FORMAT_NV16 | planar 4:2:2 YUV with interleaved UV plane |
GST_VIDEO_FORMAT_NV24 | planar 4:4:4 YUV with interleaved UV plane |
GST_VIDEO_FORMAT_NV12_64Z32 | NV12 with 64x32 tiling in zigzag pattern |

### GST_VIDEO_MAX_PLANES

    #define GST_VIDEO_MAX_PLANES 4

### GST_VIDEO_MAX_COMPONENTS

    #define GST_VIDEO_MAX_COMPONENTS 4

### struct GstVideoFormatInfo

    struct GstVideoFormatInfo {
      GstVideoFormat format;
      const gchar *name;
      const gchar *description;
      GstVideoFormatFlags flags;
      guint bits;
      guint n_components;
      guint shift[GST_VIDEO_MAX_COMPONENTS];
      guint depth[GST_VIDEO_MAX_COMPONENTS];
      gint  pixel_stride[GST_VIDEO_MAX_COMPONENTS];
      guint n_planes;
      guint plane[GST_VIDEO_MAX_COMPONENTS];
      guint poffset[GST_VIDEO_MAX_COMPONENTS];
      guint w_sub[GST_VIDEO_MAX_COMPONENTS];
      guint h_sub[GST_VIDEO_MAX_COMPONENTS];

      GstVideoFormat unpack_format;
      GstVideoFormatUnpack unpack_func;
      gint pack_lines;
      GstVideoFormatPack pack_func;

      GstVideoTileMode tile_mode;
      guint tile_ws;
      guint tile_hs;

      gpointer _gst_reserved[GST_PADDING];
    };

Information for a video format.

#### Members

GstVideoFormat `format`; | GstVideoFormat |
const gchar *`name`; | string representation of the format |
const gchar *`description`; | use readable description of the format |
GstVideoFormatFlags `flags`; | GstVideoFormatFlags |
guint `bits`; | The number of bits used to pack data items. This can be less than 8 when multiple pixels are stored in a byte. for values > 8 multiple bytes should be read according to the endianness flag before applying the shift and mask. |
guint `n_components`; | the number of components in the video format. |
guint `shift`[GST_VIDEO_MAX_COMPONENTS]; | the number of bits to shift away to get the component data |
guint `depth`[GST_VIDEO_MAX_COMPONENTS]; | the depth in bits for each component |
gint `pixel_stride`[GST_VIDEO_MAX_COMPONENTS]; | the pixel stride of each component. This is the amount of bytes to the pixel immediately to the right. When bits < 8, the stride is expressed in bits. For 24-bit RGB, this would be 3 bytes, for example, while it would be 4 bytes for RGBx or ARGB. |
guint `n_planes`; | the number of planes for this format. The number of planes can be less than the amount of components when multiple components are packed into one plane. |
guint `plane`[GST_VIDEO_MAX_COMPONENTS]; | the plane number where a component can be found |
guint `poffset`[GST_VIDEO_MAX_COMPONENTS]; | the offset in the plane where the first pixel of the components can be found. |
guint `w_sub`[GST_VIDEO_MAX_COMPONENTS]; | subsampling factor of the width for the component. Use GST_VIDEO_SUB_SCALE to scale a width. |
guint `h_sub`[GST_VIDEO_MAX_COMPONENTS]; | subsampling factor of the height for the component. Use GST_VIDEO_SUB_SCALE to scale a height. |
GstVideoFormat `unpack_format`; | the format of the unpacked pixels. This format must have the GST_VIDEO_FORMAT_FLAG_UNPACK flag set. |
GstVideoFormatUnpack `unpack_func`; | an unpack function for this format |
gint `pack_lines`; | the amount of lines that will be packed |
GstVideoFormatPack `pack_func`; | an pack function for this format |
GstVideoTileMode `tile_mode`; | The tiling mode `tile_ws` The width of a tile, in bytes, represented as a shift `tile_hs` The height of a tile, in bytes, represented as a shift |
guint `tile_ws`; |  |
guint `tile_hs`; |  |
gpointer `_gst_reserved`[GST_PADDING]; |  |

### enum GstVideoChromaSite

Various Chroma sitings.

#### Members

GST_VIDEO_CHROMA_SITE_UNKNOWN | unknown cositing |
GST_VIDEO_CHROMA_SITE_NONE | no cositing |
GST_VIDEO_CHROMA_SITE_H_COSITED | chroma is horizontally cosited |
GST_VIDEO_CHROMA_SITE_V_COSITED | chroma is vertically cosited |
GST_VIDEO_CHROMA_SITE_ALT_LINE | choma samples are sited on alternate lines |
GST_VIDEO_CHROMA_SITE_COSITED | chroma samples cosited with luma samples |
GST_VIDEO_CHROMA_SITE_JPEG | jpeg style cositing, also for mpeg1 and mjpeg |
GST_VIDEO_CHROMA_SITE_MPEG2 | mpeg2 style cositing |
GST_VIDEO_CHROMA_SITE_DV | DV style cositing |

### enum GstVideoFormatFlags

The different video flags that a format info can have.

#### Members

GST_VIDEO_FORMAT_FLAG_YUV | The video format is YUV, components are numbered 0=Y, 1=U, 2=V. |
GST_VIDEO_FORMAT_FLAG_RGB | The video format is RGB, components are numbered 0=R, 1=G, 2=B. |
GST_VIDEO_FORMAT_FLAG_GRAY | The video is gray, there is one gray component with index 0. |
GST_VIDEO_FORMAT_FLAG_ALPHA | The video format has an alpha components with the number 3. |
GST_VIDEO_FORMAT_FLAG_LE | The video format has data stored in little endianness. |
GST_VIDEO_FORMAT_FLAG_PALETTE | The video format has a palette. The palette is stored in the second plane and indexes are stored in the first plane. |
GST_VIDEO_FORMAT_FLAG_COMPLEX | The video format has a complex layout that can't be described with the usual information in the GstVideoFormatInfo. |
GST_VIDEO_FORMAT_FLAG_UNPACK | This format can be used in a GstVideoFormatUnpack and GstVideoFormatPack function. |
GST_VIDEO_FORMAT_FLAG_TILED | The format is tiled, there is tiling information in the last plane. |

### enum GstVideoPackFlags

The different flags that can be used when packing and unpacking.

#### Members

GST_VIDEO_PACK_FLAG_NONE | No flag |
GST_VIDEO_PACK_FLAG_TRUNCATE_RANGE | When the source has a smaller depth than the target format, set the least significant bits of the target to 0. This is likely sightly faster but less accurate. When this flag is not specified, the most significant bits of the source are duplicated in the least significant bits of the destination. |
GST_VIDEO_PACK_FLAG_INTERLACED | The source is interlaced. The unpacked format will be interlaced as well with each line containing information from alternating fields. (Since 1.2) |

### GST_VIDEO_SIZE_RANGE

    #define GST_VIDEO_SIZE_RANGE "(int) [ 1, max ]"

### GST_VIDEO_FPS_RANGE

    #define GST_VIDEO_FPS_RANGE "(fraction) [ 0, max ]"

### GST_VIDEO_FORMATS_ALL

    #define             GST_VIDEO_FORMATS_ALL

### enum GstVideoColorRange

Possible color range values. These constants are defined for 8 bit color values and can be scaled for other bit depths.

#### Members

GST_VIDEO_COLOR_RANGE_UNKNOWN | unknown range |
GST_VIDEO_COLOR_RANGE_0_255 | [0..255] for 8 bit components |
GST_VIDEO_COLOR_RANGE_16_235 | [16..235] for 8 bit components. Chroma has [16..240] range. |

### enum GstVideoColorMatrix

The color matrix is used to convert between Y'PbPr and non-linear RGB (R'G'B')

#### Members

GST_VIDEO_COLOR_MATRIX_UNKNOWN | unknown matrix |
GST_VIDEO_COLOR_MATRIX_RGB | identity matrix |
GST_VIDEO_COLOR_MATRIX_FCC | FCC color matrix |
GST_VIDEO_COLOR_MATRIX_BT709 | ITU-R BT.709 color matrix |
GST_VIDEO_COLOR_MATRIX_BT601 | ITU-R BT.601 color matrix |
GST_VIDEO_COLOR_MATRIX_SMPTE240M | SMPTE 240M color matrix |

### enum GstVideoTransferFunction

The video transfer function defines the formula for converting between non-linear RGB (R'G'B') and linear RGB

#### Members

GST_VIDEO_TRANSFER_UNKNOWN | unknown transfer function |
GST_VIDEO_TRANSFER_GAMMA10 | linear RGB, gamma 1.0 curve |
GST_VIDEO_TRANSFER_GAMMA18 | Gamma 1.8 curve |
GST_VIDEO_TRANSFER_GAMMA20 | Gamma 2.0 curve |
GST_VIDEO_TRANSFER_GAMMA22 | Gamma 2.2 curve |
GST_VIDEO_TRANSFER_BT709 | Gamma 2.2 curve with a linear segment in the lower range |
GST_VIDEO_TRANSFER_SMPTE240M | Gamma 2.2 curve with a linear segment in the lower range |
GST_VIDEO_TRANSFER_SRGB | Gamma 2.4 curve with a linear segment in the lower range |
GST_VIDEO_TRANSFER_GAMMA28 | Gamma 2.8 curve |
GST_VIDEO_TRANSFER_LOG100 | Logarithmic transfer characteristic 100:1 range |
GST_VIDEO_TRANSFER_LOG316 | Logarithmic transfer characteristic 316.22777:1 range |

### enum GstVideoColorPrimaries

The color primaries define the how to transform linear RGB values to and from the CIE XYZ colorspace.

#### Members

GST_VIDEO_COLOR_PRIMARIES_UNKNOWN | unknown color primaries |
GST_VIDEO_COLOR_PRIMARIES_BT709 | BT709 primaries |
GST_VIDEO_COLOR_PRIMARIES_BT470M | BT470M primaries |
GST_VIDEO_COLOR_PRIMARIES_BT470BG | BT470BG primaries |
GST_VIDEO_COLOR_PRIMARIES_SMPTE170M | SMPTE170M primaries |
GST_VIDEO_COLOR_PRIMARIES_SMPTE240M | SMPTE240M primaries |
GST_VIDEO_COLOR_PRIMARIES_FILM | Generic film |

### GstVideoColorimetry

    typedef struct {
      GstVideoColorRange        range;
      GstVideoColorMatrix       matrix;
      GstVideoTransferFunction  transfer;
      GstVideoColorPrimaries    primaries;
    } GstVideoColorimetry;

Structure describing the color info.

#### Members

GstVideoColorRange `range`; | the color range. This is the valid range for the samples. It is used to convert the samples to Y'PbPr values. |
GstVideoColorMatrix `matrix`; | the color matrix. Used to convert between Y'PbPr and non-linear RGB (R'G'B') |
GstVideoTransferFunction `transfer`; | the transfer function. used to convert between R'G'B' and RGB |
GstVideoColorPrimaries `primaries`; | color primaries. used to convert between R'G'B' and CIE XYZ |

### struct GstVideoInfo

    struct GstVideoInfo {
      const GstVideoFormatInfo *finfo;

      GstVideoInterlaceMode     interlace_mode;
      GstVideoFlags             flags;
      gint                      width;
      gint                      height;
      gsize                     size;
      gint                      views;

      GstVideoChromaSite        chroma_site;
      GstVideoColorimetry       colorimetry;

      gint                      par_n;
      gint                      par_d;
      gint                      fps_n;
      gint                      fps_d;

      gsize                     offset[GST_VIDEO_MAX_PLANES];
      gint                      stride[GST_VIDEO_MAX_PLANES];
    };

Information describing image properties. This information can be filled in from GstCaps with `gst_video_info_from_caps()`. The information is also used to store the specific video info when mapping a video frame with `gst_video_frame_map()`.

Use the provided macros to access the info in this structure.

#### Members

const GstVideoFormatInfo *`finfo`; | the format info of the video |
GstVideoInterlaceMode `interlace_mode`; | the interlace mode |
GstVideoFlags `flags`; | additional video flags |
gint `width`; | the width of the video |
gint `height`; | the height of the video |
gsize `size`; | the default size of one frame |
gint `views`; | the number of views for multiview video |
GstVideoChromaSite `chroma_site`; | a GstVideoChromaSite. |
GstVideoColorimetry `colorimetry`; | the colorimetry info |
gint `par_n`; | the pixel-aspect-ratio numerator |
gint `par_d`; | the pixel-aspect-ratio demnominator |
gint `fps_n`; | the framerate numerator |
gint `fps_d`; | the framerate demnominator |
gsize `offset`[GST_VIDEO_MAX_PLANES]; | offsets of the planes |
gint `stride`[GST_VIDEO_MAX_PLANES]; | strides of the planes |

### enum GstVideoInterlaceMode

The possible values of the GstVideoInterlaceMode describing the interlace mode of the stream.

#### Members

GST_VIDEO_INTERLACE_MODE_PROGRESSIVE | all frames are progressive |
GST_VIDEO_INTERLACE_MODE_INTERLEAVED | 2 fields are interleaved in one video frame. Extra buffer flags describe the field order. |
GST_VIDEO_INTERLACE_MODE_MIXED | frames contains both interlaced and progressive video, the buffer flags describe the frame and fields. |
GST_VIDEO_INTERLACE_MODE_FIELDS | 2 fields are stored in one buffer, use the frame ID to get access to the required field. For multiview (the 'views' property > 1) the fields of view N can be found at frame ID (N * 2) and (N * 2) + 1. Each field has only half the amount of lines as noted in the height property. This mode requires multiple GstVideoMeta metadata to describe the fields. |

### enum GstVideoFlags

Extra video flags

#### Members

GST_VIDEO_FLAG_NONE | no flags |
GST_VIDEO_FLAG_VARIABLE_FPS | a variable fps is selected, fps_n and fps_d denote the maximum fps of the video |
GST_VIDEO_FLAG_PREMULTIPLIED_ALPHA | Each color has been scaled by the alpha value. |

### struct GstVideoFrame

    struct GstVideoFrame {
      GstVideoInfo info;
      GstVideoFrameFlags flags;

      GstBuffer *buffer;
      gpointer   meta;
      gint       id;

      gpointer   data[GST_VIDEO_MAX_PLANES];
      GstMapInfo map[GST_VIDEO_MAX_PLANES];
    };

A video frame obtained from `gst_video_frame_map()`

#### Members

GstVideoInfo `info`; | the GstVideoInfo |
GstVideoFrameFlags `flags`; |  |
GstBuffer *`buffer`; | the mapped buffer |
gpointer `meta`; | pointer to metadata if any |
gint `id`; | id of the mapped frame. the id can for example be used to indentify the frame in case of multiview video. |
gpointer `data`[GST_VIDEO_MAX_PLANES]; | pointers to the plane data |
GstMapInfo `map`[GST_VIDEO_MAX_PLANES]; | mappings of the planes |

### enum GstVideoFrameFlags

Extra video frame flags

#### Members

GST_VIDEO_FRAME_FLAG_NONE | no flags |
GST_VIDEO_FRAME_FLAG_INTERLACED | The video frame is interlaced. In mixed interlace-mode, this flags specifies if the frame is interlace or progressive. |
GST_VIDEO_FRAME_FLAG_TFF | The video frame has the top field first |
GST_VIDEO_FRAME_FLAG_RFF | The video frame has the repeat flag |
GST_VIDEO_FRAME_FLAG_ONEFIELD | The video frame has one field |

### enum GstVideoBufferFlags

Additional video buffer flags.

#### Members

GST_VIDEO_BUFFER_FLAG_INTERLACED | If the GstBuffer is interlaced. In mixed interlace-mode, this flags specifies if the frame is interlaced or progressive. |
GST_VIDEO_BUFFER_FLAG_TFF | If the GstBuffer is interlaced, then the first field in the video frame is the top field. If unset, the bottom field is first. |
GST_VIDEO_BUFFER_FLAG_RFF | If the GstBuffer is interlaced, then the first field (as defined by the `GST_VIDEO_BUFFER_TFF` flag setting) is repeated. |
GST_VIDEO_BUFFER_FLAG_ONEFIELD | If the GstBuffer is interlaced, then only the first field (as defined by the `GST_VIDEO_BUFFER_TFF` flag setting) is to be displayed. |
GST_VIDEO_BUFFER_FLAG_LAST |  |

### enum GstVideoTileType

Enum value describing the most common tiling types.

#### Members

GST_VIDEO_TILE_TYPE_INDEXED | Tiles are indexed. Use `gst_video_tile_get_index()` to retrieve the tile at the requested coordinates. |

### enum GstVideoTileMode

Enum value describing the available tiling modes.

#### Members

GST_VIDEO_TILE_MODE_UNKNOWN | Unknown or unset tile mode |
GST_VIDEO_TILE_MODE_ZFLIPZ_2X2 | Every four adjacent blocks - two horizontally and two vertically are grouped together and are located in memory in Z or flipped Z order. In case of odd rows, the last row of blocks is arranged in linear order. |